// Simulate Rabbit population growth as Fibonacci did. This version
// uses ArrayLists and a class for Rabbits to track their age.

import java.util.*;

class Rabbits{
  public int age;
  public int parents;
  public Rabbits(int a, int p){
    this.age=a; 
    this.parents=p;
  }
  public String toString(){
    String s = (age == 0) ? "B" : "M";
    String p = (parents == -1) ? "I" : ""+parents;
    return s+p;
  }
}

public class RabbitSim{
  public static List<Rabbits> generation(int g){
    ArrayList<Rabbits> cur = new ArrayList<Rabbits>();
    
    // Is this pre-rabbits?
    if(g == 0){
      return cur;
    }

    // Is this the first generation?
    if(g == 1){
      Rabbits r = new Rabbits(0,-1);
      cur.add(r);
      return cur;
    }
    // Nope
    List<Rabbits> last = generation(g-1);
    // Add the last generation to the current, age by 1.  This makes a
    // deep copy
    for(int i=0; i<last.size(); i++){
      Rabbits r = last.get(i);
      cur.add(new Rabbits(r.age+1, r.parents));
    }
    // Add the next generation
    for(int i=0; i<last.size(); i++){
      Rabbits r = cur.get(i);
      if(r.age >= 2){
	cur.add(new Rabbits(0,i));
      }
    }
    return cur;
  }

  public static void main(String args[]){
    if(args.length < 1){
      System.out.println("usage: java RabbitSim N");
      return;
    }

    int n = Integer.parseInt(args[0]);
    for(int i=0; i<= n; i++){
      List<Rabbits> l = generation(i);
      System.out.printf("%2d %6d %s\n",
			i,l.size(), l);
    }
  }
}
